from django.db import models
from django.forms import ModelForm, DateField, ChoiceField, RadioSelect
from django.contrib.admin.widgets import AdminDateWidget

from .models import Project, Volunteer, IFG, Library

class ProjectForm(ModelForm):

    start = DateField(widget=AdminDateWidget)

    class Meta:
        model = Project
        exclude = ('pid',)

class VolunteerForm(ModelForm):

    CHOICES = [('IFG','ifg'),
               ('Lib','library'),]
    choice = ChoiceField(choices=CHOICES, widget=RadioSelect)

    class Meta:
        model = Volunteer
        fields = '__all__'

class LibraryForm(ModelForm):
    class Meta:
        model = Library
        exclude = ('realname', 'email', 'username')

class IFGForm(ModelForm):
    class Meta:
        model = IFG
        exclude = ('realname', 'email', 'username')
